 % ALGORITMO PARA EL CALCULO DEL VOLUMEN DE UNA BOTELLA DE VIDRIO
 % Para construir la spline cubica natural S que interpola a la funcion f,
 % definida en los puntos x(0) < x(1) < ... < x(n), verificando
 % S''(x(0)) = S''(x(n)) = 0:
 %
 % ENTRADA:   X(I)= x(0), x(1), ..., x(n);  
 %            A(I) = f(X(I));
 %            para I = 0, 1, ..., n 
 %
 % SALIDA:  A(J), B(J), C(J), D(J) para J = 0, 1, ..., n - 1.
 %
 % NOTE:    S(x) = A(J) + B(J)*( x - x(J) ) + C(J)*( x - x(J) )**2 +
 %          D(J) * ( x - x(J) )**3 for x(J) <= x < x(J + 1) 
 
 function [volContinente, volContenido , y, v] = volumen(X,A,N, GRUESO)
 
 syms('OK','FLAG','I','AA','INP','F','M','H','XA')
 syms('XL','XU','XZ','C','J','B','D','OUP','x','s');
 TRUE=1;
 FALSE=0;


 M = N - 1;
% STEP 1
 H = zeros(1,M+1);
 for I = 0:M
    H(I+1) = X(I+2) - X(I+1);
 end
% STEP 2
% Use XA in place of ALPHA
 XA = zeros(1,M+1);
 for I = 1:M
    XA(I+1) = 3.0*(A(I+2)*H(I)-A(I+1)*(X(I+2)-X(I))+A(I)*H(I+1))/(H(I+1)*H(I));
 end
% STEP 3
% STEPs 3, 4, 5 and part of 6 solve the tridiagonal system using 
% Crout reduction.
% use XL, XU, XZ in place of L, MU, Z resp.
 XL = zeros(1,N+1);
 XU = zeros(1,N+1);
 XZ = zeros(1,N+1);
 XL(1) = 1;
 XU(1) = 0;
 XZ(1) = 0;
% STEP 4
    for I = 1:M
 XL(I+1) = 2*(X(I+2)-X(I))-H(I)*XU(I);
 XU(I+1) = H(I+1)/XL(I+1);
 XZ(I+1) = (XA(I+1)-H(I)*XZ(I))/XL(I+1);
    end
% STEP 5
 XL(N+1) = 1;
 XZ(N+1) = 0;
 B = zeros(1,N+1);
 C = zeros(1,N+1);
 D = zeros(1,N+1);
 C(N+1) = XZ(N+1);
% STEP 6
    for I = 0:M
 J = M-I;
 C(J+1) = XZ(J+1)-XU(J+1)*C(J+2);
 B(J+1) = (A(J+2)-A(J+1))/H(J+1) - H(J+1) * (C(J+2) + 2.0 * C(J+1)) / 3.0;
 D(J+1) = (C(J+2) - C(J+1)) / (3.0 * H(J+1));
    end
% STEP 7

% OUP = 1;
% fprintf(OUP, 'INTERPOLACION SPLINE CUBICA NATURAL n\n');
% fprintf(OUP, 'Los puntos X(0), ..., X(N) son:\n');
%    for I = 0:N
% fprintf(OUP, ' %11.8f', X(I+1));
%    end
% fprintf(OUP, '\n\nLos coeficientes de la spline en los subintervalos '); 
% fprintf(OUP, 'son:\n');
% fprintf(OUP, 'Para I = 0, ..., N-1\n');
% fprintf(OUP, '     A(I)          B(I)           C(I)         D(I)\n');
%    for I = 0:M
% fprintf(OUP,'%13.8f %13.8f %13.8f %13.8f \n',A(I+1),B(I+1),C(I+1),D(I+1));
%   end

 y = zeros(1,101*(M+1));
 v = zeros(1,101*(M+1));
    for J = 1:M+1    
        for I = 1:101
            v(101*(J-1)+I)=X(J) + (I-1)*(X(J+1)-X(J))/100;
            y(101*(J-1)+I)=A(J)+B(J)*(v(101*(J-1)+I)-X(J))+C(J)*(v(101*(J-1)+I)-X(J))^2+D(J)*(v(101*(J-1)+I)-X(J))^3;
        end
    end

 JX= zeros(N);
 XI= zeros(5);
 WI= zeros(5);
 XI(1)= 0.9061798459;
 XI(2)= 0.5384693101;
 XI(3)= 0.0;
 XI(4)= -XI(2);
 XI(5)= -XI(1);
 WI(1)= 0.2369268850;
 WI(2)= 0.4786286705;
 WI(3)= 0.5688888889;
 WI(4)= WI(2);
 WI(5)= WI(1);
 
 for J=1:N
    JX(J)= 0;
    for I=1:5
        K1=(X(J+1)-X(J))/2;
        K2=(X(J+1)+X(J))/2;
        XX=K1*XI(I)+K2;
        Q=pi*[A(J)+B(J)*(XX-X(J))+C(J)*(XX-X(J))^2+D(J)*(XX-X(J))^3]^2;
        JX(J)=JX(J)+WI(I)*Q;
    end
    JX(J)=JX(J)*K1;
end
INT1=0;
for J=1:N
  INT1=INT1+JX(J);
end

for J=1:N
     JX(J)= 0;
    for I=1:5
        K1=(X(J+1)-X(J))/2;
        K2=(X(J+1)+X(J))/2;
        XX=K1*XI(I)+K2;
        P=pi*[A(J)+B(J)*(XX-X(J))+C(J)*(XX-X(J))^2+D(J)*(XX-X(J))^3-GRUESO]^2;
        JX(J)=JX(J)+WI(I)*P;
    end
    JX(J)=JX(J)*K1;
end

INT2=0;
for J=1:N
  INT2=INT2+JX(J);
end
INT3=0;
INT3=INT1-INT2;
INT4=0;
INT4=INT1-INT3;

volContenido = INT4;
volContinente = INT3;





   
